//phidels.com
unit Unit1;
{************ Important : voir aussi le source de Project1**********}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ShellAPI,
  ExtCtrls, StdCtrls, Menus;

Const WM_MYMESSAGE=WM_USER+100; // numro de message utilis plus bas.

type
  TForm1 = class(TForm)
    Image1: TImage;
    Buttonfermer: TButton;
    ButtonCacherfiche: TButton;
    PopupMenu1: TPopupMenu;
    PopFermer: TMenuItem;
    PopMontrerLaFiche: TMenuItem;
    popCacherLaFiche: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonfermerClick(Sender: TObject);
    procedure ButtonCacherficheClick(Sender: TObject);
    procedure PopFermerClick(Sender: TObject);
    procedure popCacherLaFicheClick(Sender: TObject);
    procedure PopMontrerLaFicheClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure TrayMessage(var Msg: TMessage); message WM_MYMESSAGE;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
//  NotifyStruc : TNotifyIconData; 
  PNotifyStruc: PNotifyIconData; // pointeur sur la "structure" de l'icne
implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
var
  hinte:string;
  j:integer;
begin
  New(PNotifyStruc); //Cre une nouvelle variable dynamique
                     //Syntaxe pour accder au contenu de la variable
                     //pointe par PNotifyStruc : PNotifyStruc^
  // initialisation de la variable pointe par PNotifyStruc :
  PNotifyStruc^.cbSize:=SizeOf(PNotifyStruc^);
  PNotifyStruc^.Wnd:=Handle;
  PNotifyStruc^.uID:=1;
  PNotifyStruc^.uFlags := NIF_ICON or NIF_TIP or NIF_MESSAGE;
  { On verra WM_MYMESSAGE plus tard }
  PNotifyStruc^.uCallbackMessage := WM_MYMESSAGE;
  { Image1 est un composant TImage }
  PNotifyStruc^.hIcon :=  Form1.Image1.Picture.Icon.Handle;
  { Dfinir l'Hint de l'icne, c-a-d le texte qui sera affich quand la souris reste longtemps dessus }
  hinte:='cliquez moi !';
  for j:=0 to length(hinte)-1 do PNotifyStruc^.szTip[j] := hinte[j+1];
  PNotifyStruc^.szTip[length(hinte)]:=#0;

  Shell_NotifyIcon(NIM_ADD,PNotifyStruc);//ajoute la petite icne dans la barre des taches
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (PNotifyStruc<>NIL) then
   begin
     Shell_NotifyIcon(NIM_DELETE,PNotifyStruc);//retire la petite icne de la barre des taches
      Dispose(PNotifyStruc);
   end;
end;

procedure TForm1.TrayMessage(var Msg: TMessage);// message WM_MYMESSAGE;
//Le fait d'voir dclar dans form1 procedure TrayMessage(var Msg: TMessage); message WM_MYMESSAGE;
//et d'avoir fait NotifyStruc.uCallbackMessage := WM_MYMESSAGE indique au programme que tout message destin  la petite icone (try icons)
//doit dclencher la procdure TrayMessage

var coordonnes_souris :TPoint;
begin
  //('Bouton droit press on affiche le menu pop');
  if (Msg.LParam=WM_RBUTTONDOWN) then
  begin
    GetCursorPos(coordonnes_souris);//rcupration de la position de la souris
    SetForegroundWindow(Handle); // mise en avant plan de l'application
    PopupMenu1.Popup(coordonnes_souris.x,coordonnes_souris.y); //affichage du menu
  end;
  if (Msg.LParam=WM_LBUTTONDOWN) then { Bouton gauche }
  begin
    Form1.Visible:=true;
    ShowWindow(Application.Handle, SW_SHOW);
  end;
end;

procedure TForm1.ButtonfermerClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.ButtonCacherficheClick(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE); // retirer la grande icne de la barre des tches
  Form1.Visible:=false; //cacher la fiche
end;


{================================================}
{implmentation pour les actions sur le menu pop }
{================================================}

procedure TForm1.PopFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.popCacherLaFicheClick(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE); // retirer la grande icne de la barre des tches
  Form1.Visible:=false; //cacher la fiche
end;

procedure TForm1.PopMontrerLaFicheClick(Sender: TObject);
begin
  Form1.Visible:=true;
  ShowWindow(Application.Handle, SW_SHOW);
end;

end.
